var _excluded = ["content", "className", "onSetSrc", "longTapSave"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/* eslint-disable @typescript-eslint/ban-ts-comment */
import React, { useEffect, useMemo, useRef } from 'react';
import { Image } from 'remax/one';
import dayjs from 'dayjs'; // @ts-ignore

import QR from 'qrcode-base64';
import { getFileSystemManager, saveImageToPhotosAlbum } from 'remax/wechat';
export default (function (_ref) {
  var content = _ref.content,
      className = _ref.className,
      onSetSrc = _ref.onSetSrc,
      longTapSave = _ref.longTapSave,
      restProps = _objectWithoutProperties(_ref, _excluded);

  var src = useMemo(function () {
    return QR.drawImg(content, {
      typeNumber: 4,
      errorCorrectLevel: 'L',
      size: 500
    });
  }, [content]);
  useEffect(function () {
    onSetSrc === null || onSetSrc === void 0 ? void 0 : onSetSrc(src);
  }, [onSetSrc, src]);
  var timer = useRef();
  return /*#__PURE__*/React.createElement(Image, _objectSpread({
    className: className,
    src: src,
    mode: "aspectFill",
    onTouchStart: function onTouchStart() {
      return longTapSave && (timer.current = dayjs(new Date()));
    },
    onTouchEnd: function onTouchEnd() {
      if (longTapSave && timer.current && dayjs(new Date()).diff(timer.current, 'second') > 2) {
        // @ts-ignore
        var path = "".concat(wx.env.USER_DATA_PATH, "/").concat(+new Date(), ".png");
        return getFileSystemManager().writeFile({
          filePath: path,
          data: src.slice(22),
          encoding: 'base64',
          success: function success() {
            return saveImageToPhotosAlbum({
              filePath: path
            });
          }
        });
      }
    }
  }, restProps));
});